#%%define snapdate 20061116

%define pkg_name gtk2hs
%define ghc_version 6.8.3

%define build_docs 1
%define build_mozembed 0
%define build_cairo 1
%define build_opengl 1

%define pkg_libdir %{_libdir}/ghc-%{ghc_version}/%{pkg_name}-%{version}
%define pkg_docdir %{_docdir}/ghc/libraries/%{pkg_name}

Summary:        A Haskell GUI library based on the Gtk+ GUI toolkit
Name:           gtk2hs
Version:        0.9.13
Release:        3%{?dist}
# cairo/ and svgcairo/ are FreeBSD
# compat/ is BSD
# tools/c2hs (used to build) is GPL, LGPL
# except tools/c2hs/base/general/{Binary.hs,FastMutInt.hs} from ghc (BSD)
# rest is all LGPL
License:        LGPLv2+
Group:          Development/Libraries
Source:         http://prdownloads.sourceforge.net/%{name}/%{name}-%{version}%{?snapdate:-%{snapdate}}.tar.gz
Patch0:         gtk2hs-fasm-0.9.13.patch
URL:            http://gtk2hs.sourceforge.net/
# See https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=239752
ExcludeArch:	alpha ppc64
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  ghc = %{ghc_version}
%if %{build_docs}
BuildRequires:  haddock09
%endif
BuildRequires:  gtk2-devel
BuildRequires:  gtksourceview-devel
BuildRequires:  libglade2-devel
BuildRequires:  GConf2-devel
%if %{build_mozembed}
BuildRequires:  xulrunner-devel
%endif
%if %{build_cairo}
BuildRequires:  cairo-devel
%endif
%if %{build_opengl}
BuildRequires:  gtkglext-devel
%endif

%description
A Gtk+ binding for the functional language Haskell featuring
automatic memory management, unicode support, and wide
coverage of Gtk+ 2 widgets.


%package -n ghc-%{name}
Summary:        A Haskell GUI library based on the Gtk+ GUI toolkit
Group:          Development/Libraries
Requires:       ghc = %{ghc_version}
Obsoletes:      ghc661-%{name}, ghc682-%{name}
Requires:       gtk2-devel
Requires:       GConf2-devel
Requires:       libglade2-devel
Requires:       gtksourceview-devel
Requires(post): %{_bindir}/ghc-pkg-%{ghc_version}
Requires(preun): %{_bindir}/ghc-pkg-%{ghc_version}
Obsoletes:      ghc661-%{name}-mozembed, ghc682-%{name}-mozembed

%description -n ghc-%{name}
A Gtk+ binding for the functional language Haskell featuring automatic memory
management, unicode support, and wide coverage of Gtk+ 2 widgets.

This package also includes the bindings for cairo, gconf, glade, glib, and
sourceview.  The libraries are compiled for ghc-%{ghc_version}.


%if %{build_docs}
%package -n ghc-%{name}-doc
Summary:        Haskell Gtk+ GUI library documentation
Group:          Development/Libraries
Obsoletes:      gtk2hs-doc < 0.9.13-3

%description -n ghc-%{name}-doc
A Gtk+ binding for the functional language Haskell featuring automatic
memory management, unicode support, and wide coverage of Gtk+ 2
widgets.

This package contains the gtk2hs documentation.
%endif

%if %{build_opengl}
%package -n ghc-%{name}-gtkglext
Summary:        Haskell binding for gtkglext
Group:          Development/Libraries
Requires:       ghc = %{ghc_version}
Requires:       ghc-%{name} = %{version}-%{release}
Requires:       gtkglext
Requires(post): %{_bindir}/ghc-pkg-%{ghc_version}
Requires(preun): %{_bindir}/ghc-pkg-%{ghc_version}

%description -n ghc-%{name}-gtkglext
A Haskell binding of GtkGlExt for gtk2hs.
%endif


%if %{build_mozembed}
%package -n ghc-%{name}-mozembed
Summary:        Haskell binding for gtkembedmoz
Group:          Development/Libraries
Requires:       ghc = %{ghc_version}
Requires:       ghc-%{name} = %{version}-%{release}
Requires:       firefox-devel
Requires(post): %{_bindir}/ghc-pkg-%{ghc_version}
Requires(preun): %{_bindir}/ghc-pkg-%{ghc_version}

%description -n ghc-%{name}-mozembed
A Haskell binding of GtkEmbedMoz for gtk2hs.
%endif


# the debuginfo subpackage is currently empty anyway, so don't generate it
%define debug_package %{nil}


%prep
%setup -q %{?snapdate:-n %{name}-%{version}}
%ifarch ppc
%patch0 -p1 -b .0-fasm-ppc~
%endif

%build
%if %{build_docs}
export HADDOCK=%{_bindir}/haddock-0.9
%endif
%configure \
        --with-hc=ghc-%{ghc_version} \
        --enable-packager-mode \
%if %{build_docs}
        --enable-docs \
%endif
        --enable-libglade \
        --enable-gconf \
        --enable-sourceview \
%if %{build_mozembed}
        --enable-firefox \
%endif
%if %{build_opengl}
        --enable-opengl \
%endif
%if %{build_cairo}
        --enable-cairo
%endif

# C locale to workaround c2hs failing in CJK locale
LANG=C make all pkglibdir=%{pkg_libdir} htmldocdir=%{pkg_docdir}


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot} pkglibdir=%{pkg_libdir} htmldocdir=%{pkg_docdir}

# make ghost files
for i in gconf glade glib gtk sourceview soegtk \
%if %{build_cairo}
        cairo \
%endif
%if %{build_mozembed}
        mozembed \
%endif
        ; do
  touch %{buildroot}%{pkg_libdir}/HS${i}.o
done


%clean
rm -rf %{buildroot}


%define ghcpkg_inst() ghc-pkg-%{ghc_version} update --auto-ghci-libs  %{pkg_libdir}/%{1}.package.conf &>/dev/null

%define ghcpkg_uninst() ghc-pkg-%{ghc_version} unregister %{1} &>/dev/null || :


%post -n ghc-%{name}
for i in glib \
%if %{build_cairo}
        cairo \
%endif
        gtk \
        gconf \
        glade \
        sourceview \
	soegtk \
; do
%{ghcpkg_inst $i}
done

%preun -n ghc-%{name}
if [ "$1" = 0 ]; then
  for i in \
	soegtk \
        gconf \
        glade \
        sourceview \
        gtk \
%if %{build_cairo}
        cairo \
%endif
        glib \
; do
%{ghcpkg_uninst $i}
done
fi

%if %{build_docs}
%post -n ghc-%{name}-doc
%ghc_reindex_haddock

%postun -n ghc-%{name}-doc
%ghc_reindex_haddock
%endif

%if %{build_mozembed}
%post -n ghc-%{name}-mozembed
%{ghcpkg_inst mozembed}

%preun -n ghc-%{name}-mozembed
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst mozembed}
fi
%endif

%if %{build_opengl}
%post -n ghc-%{name}-gtkglext
%{ghcpkg_inst gtkglext}

%preun -n ghc-%{name}-gtkglext
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst gtkglext}
fi
%endif


%files -n ghc-%{name}
%defattr(-,root,root,-)
%doc AUTHORS COPYING
%dir %{pkg_libdir}
%{pkg_libdir}/gtk.package.conf
%{pkg_libdir}/libHSgtk.a
%ghost %{pkg_libdir}/HSgtk.o
%dir %{pkg_libdir}/imports
%{pkg_libdir}/imports/gtk
%if %{build_cairo}
%{pkg_libdir}/cairo.package.conf
%{pkg_libdir}/libHScairo.a
%ghost %{pkg_libdir}/HScairo.o
%{pkg_libdir}/imports/cairo
%endif
%{pkg_libdir}/gconf.package.conf
%{pkg_libdir}/libHSgconf.a
%ghost %{pkg_libdir}/HSgconf.o
%{pkg_libdir}/imports/gconf
%{pkg_libdir}/glade.package.conf
%{pkg_libdir}/libHSglade.a
%ghost %{pkg_libdir}/HSglade.o
%{pkg_libdir}/imports/glade
%{pkg_libdir}/glib.package.conf
%{pkg_libdir}/libHSglib.a
%ghost %{pkg_libdir}/HSglib.o
%{pkg_libdir}/imports/glib
%dir %{pkg_libdir}/include
%{pkg_libdir}/include/gtk2hs-config.h
%{pkg_libdir}/soegtk.package.conf
%{pkg_libdir}/libHSsoegtk.a
%ghost %{pkg_libdir}/HSsoegtk.o
%{pkg_libdir}/imports/soegtk
%{pkg_libdir}/sourceview.package.conf
%{pkg_libdir}/libHSsourceview.a
%ghost %{pkg_libdir}/HSsourceview.o
%{pkg_libdir}/imports/sourceview


%if %{build_docs}
%files -n ghc-%{name}-doc
%defattr(-,root,root,-)
%doc ChangeLog TODO demo
%{pkg_docdir}
%endif


%if %{build_mozembed}
%files -n ghc-%{name}-mozembed
%defattr(-,root,root,-)
%{pkg_libdir}/mozembed.package.conf
%{pkg_libdir}/libHSmozembed.a
%ghost %{pkg_libdir}/HSmozembed.o
%{pkg_libdir}/imports/mozembed
%endif


%if %{build_opengl}
%files -n ghc-%{name}-gtkglext
%defattr(-,root,root,-)
%{pkg_libdir}/gtkglext.package.conf
%{pkg_libdir}/libHSgtkglext.a
%ghost %{pkg_libdir}/HSgtkglext.o
%{pkg_libdir}/imports/gtkglext
%endif


%changelog
* Fri Oct 24 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-3
- install docs in ghc haddock dir with htmldocdir and use ghc_reindex_haddock
- rename gtk2hs-doc to ghc-gtk2hs-doc
- use pkg_name, pkg_libdir, and pkg_docdir for Haskell packaging guidelines
- don't override __spec_install_post

* Mon Jul 14 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-2
- Try to fix ppc build due to ghc 6.8.3 -fvia-C bug

* Mon Jul 14 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-1
- Update to 0.9.13

* Mon Jun 23 2008 Jens Petersen <petersen@redhat.com> - 0.9.12.1-10.fc10
- build with ghc-6.8.3
- add build_docs switch
- use haddock09 to fix build failure (#440493)
- merge ghcver subpackage into ghc subpackage in line with ghc
- obsolete old ghcver packages
- add opengl gtkglext subpackage (Ian Collier, #327541)
- require xulrunner-devel instead of firefox-devel
- update prereq's to script requires

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.12.1-9
- Autorebuild for GCC 4.3

* Thu Dec 13 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-7
* Fix typo

* Thu Dec 13 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-7
* Build with ghc 6.8.2

* Fri Nov 23 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-6
* Exclude alpha

* Fri Nov 09 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-5
* Bump revision number

* Wed Nov 07 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-4
* Revert to 0.9.12 spec file

* Thu Aug 16 2007 Jens Petersen <petersen@redhat.com>
- update License field

* Fri Jul 27 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12-1
- update to 0.9.12 release

* Thu May 10 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.11-4
- disable ppc64 build (#239752)

* Thu May 10 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.11-3
- rebuild against ghc 6.6.1

* Tue Apr 10 2007 Jens Petersen <petersen@redhat.com> - 0.9.11-2
- obsolete mozembed when it is not built

* Thu Mar 22 2007 Jens Petersen <petersen@redhat.com> - 0.9.11-1
- update to 0.9.11 release
- disable mozembed for now since the firefox minor version keeps changing
  (#223880)

* Thu Nov 16 2006 Jens Petersen <petersen@redhat.com> - 0.9.10.2-0.1
- update to latest darcs snapshot for ghc66
- add soegtk and remove mogul ghc packages

* Thu Sep 28 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-4
- rebuild for FC6

* Sun Aug 20 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-3
- drop explicit firefox-devel version to avoid rebuild every time it changes
  (cf #202395)

* Wed Aug  2 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-2
- mozilla-devel is now firefox-devel

* Mon May 15 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-1
- rework packaging to keep all the ghc packages together except mozembed
- update mozilla version to 1.7.13

* Mon May  1 2006 Gérard Milmeister <gemi@bluewin.ch>
- spec file cleanup
- ghost the .o files generated at install time
- move the docs to a versioned dir and include the demos
- make all subpackages own %%{_libdir}/ghc

* Tue Apr 25 2006 Jens Petersen <petersen@redhat.com>
- use module names for the subpackages
- subpackage mogul
- own the include dir

* Sat Apr 22 2006 Jens Petersen <petersen@redhat.com>
- initial packaging for Fedora Extras
- define ghcpkg_inst and ghcpkg_uninst for post and preun scripts and
  silence ghc-pkg
- own include/

* Wed Oct 26 2005 Jens Petersen <petersen@redhat.com> - 0.9.9.7-0
- rc

* Wed Sep 21 2005 Jens Petersen <petersen@redhat.com> - 0.9.9-2
- build with ghc-6.4.1

* Sat Jul 30 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-3
- drop old conflicts

* Tue Jul  5 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-2
- use %%configure to configure for arch to avoid gclosure ghci-6.4 linking
  problems on i386

* Wed Jun 22 2005 Jens Petersen <petersen@haskell.org> - 0.9.8-1
- update to 0.9.8
- use new --enable-packager-mode and --enable-* configure options

* Thu Jun  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7.91
- update to rc1
- add build_mozembed macro and use it

* Mon May  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7-2
- add gtk2hs-0.9.7-ghc64.patch and build with ghc-6.4 (Duncan Coutts)
  - .pkg files are now .cabal files

* Tue Jan 18 2005 Duncan Coutts <duncan@coutts.uklinux.net>
- cleanup requirements, summaries, descriptions, and configure invocation
- update preun scripts

* Thu Aug 19 2004 Jens Petersen <petersen@haskell.org>
- use suffix -ghc621 instead of -ghc6.2.1 and conflict with old packages
- buildrequire ghc-doc and gtk2hs-doc-ghc621 requires ghc-doc
- move docs and demo files to %{_defaultdocdir}/gtk2hs

* Mon Aug 16 2004 Jens Petersen <petersen@haskell.org>
- update to 0.9.6

* Thu Jul 22 2004 Jens Petersen <petersen@haskell.org>
- split sourceview and glade into separate subpackages
- require -devel packages rather than lib pkg for gtk2, gtksourceview,
  and libglade2

* Wed Mar 24 2004 Jens Petersen <petersen@haskell.org>
- enable gtksourceview and glade configure options
- use mkdir -p instead of mkdirhier
- update file locations in %%post and %%preun scripts
- buildrequire libglade2-devel

* Tue Nov 11 2003 Jens Petersen <petersen@haskell.org>
- use %%c2hs instead of "--with c2hs" to configure c2hs program
- clean demo to avoid binary files in docs dir

* Mon Nov  3 2003 Jens Petersen <petersen@haskell.org>
- add sourceview package to %%post and %%preun
- install gtksourceview haskell.lang language-spec

* Thu Jul 31 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0.1
- put demo dir in docs dir rather than individual source files

* Thu Jul 10 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0
- name ghc subpackage "ghc%%{ghc_version}"

* Wed Jun 18 2003 Jens Petersen <petersen@haskell.org>
- require and buildrequire %{_bindir}/ghc-%%{ghc_version}

* Wed May 21 2003 Jens Petersen <petersen@haskell.org>
- add -g option to ghc-pkg -u so that ghci object gets generated
- delete them when uninstalling
- build and include mogul documentation

* Thu May 15 2003 Jens Petersen <petersen@haskell.org>
- use new DESTDIR make variable, so no longer need to fix config files in post
- remove buildroot before install
- build and include gtk docs

* Fri Jan 10 2003 Jens Petersen <petersen@haskell.org>
- made into .spec.in file
- let configure set the version
- update description
- introduce --with-c2hs rpmbuild option
- use perl to remove buildroot traces from package conf files
- simplify ghc-pkg update commands

* Tue Dec 17 2002 Jens Petersen <petersen@haskell.org>
- latest cvs with ghc 5.04.2

* Thu Sep 26 2002 Jens Petersen
- build with ghc-5.04.1

* Fri Aug  2 2002 Jens Petersen
- only include demo source in doc dir

* Fri Jul 26 2002 Jens Petersen
- build with ghc-5.04
- cvs update

* Wed Jul 10 2002 Jens Petersen
- my current branch

* Wed May  1 2002 Jens Petersen
- patch TreeViewColumn.chs to make it usable

* Tue Apr 23 2002 Jens Petersen
- 0.9.0
- update gtk2 and mogul ghc-pkg entries on upgrade

* Fri Apr 12 2002 Jens Petersen
- adapt for gtk2hs
- fix mk files for buildroot install
- post and postun scriptlets for pkg config

* Tue Mar 12 2002 Manuel Chakravarty
- require a specific Haskell compiler (namely, the one for which the packages 
  was compiled)

* Sat Feb 17 2001 Manuel Chakravarty
- derived from C->Haskell's .spec file
